=== modified file 'conf/okular.kcfg'
--- conf/okular.kcfg	2011-12-14 13:28:07 +0000
+++ conf/okular.kcfg	2011-12-23 22:53:33 +0000
@@ -3,8 +3,8 @@
       xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
       xsi:schemaLocation="http://www.kde.org/standards/kcfg/1.0
       http://www.kde.org/standards/kcfg/1.0/kcfg.xsd" >
+ <include>kuser.h</include>
  <kcfgfile arg="true" />
- <include>kuser.h</include>
  <group name="Debugging Options" >
   <entry key="DebugDrawBoundaries" type="Bool" >
    <default>false</default>

=== modified file 'core/action.cpp'
--- core/action.cpp	2011-12-14 13:28:07 +0000
+++ core/action.cpp	2011-12-23 22:53:33 +0000
@@ -429,49 +429,3 @@
     return i18n( "Play movie..." );
 }
 #endif
-
-// FormAction
-
-class Okular::ResetFormActionPrivate : public Okular::ActionPrivate
-{
-    public:
-        ResetFormActionPrivate( const QStringList &fieldList, ResetFormAction::Behaviour behaviour )
-            : ActionPrivate(), m_fieldList(fieldList), m_behaviour(behaviour)
-        {
-        }
-
-    QStringList m_fieldList;
-    ResetFormAction::Behaviour m_behaviour;
-};
-
-ResetFormAction::ResetFormAction( const QStringList &fieldList, Behaviour behaviour )
-    : Action( *new ResetFormActionPrivate( fieldList, behaviour ) )
-{
-}
-
-ResetFormAction::~ResetFormAction()
-{
-}
-
-Action::ActionType ResetFormAction::actionType() const
-{
-    return ResetForm;
-}
-
-QString ResetFormAction::actionTip() const
-{
-    return i18n( "Reset Forms" );
-}
-
-ResetFormAction::Behaviour ResetFormAction::behaviour() const
-{
-    Q_D( const Okular::ResetFormAction );
-    return d->m_behaviour;
-}
-
-QStringList ResetFormAction::fieldList() const
-{
-    Q_D( const Okular::ResetFormAction );
-    return d->m_fieldList;
-}
-

=== modified file 'core/action.h'
--- core/action.h	2011-12-14 13:28:07 +0000
+++ core/action.h	2011-12-23 22:53:33 +0000
@@ -27,7 +27,6 @@
 class MovieActionPrivate;
 class Sound;
 class DocumentViewport;
-class ResetFormActionPrivate;
 
 /**
  * @short Encapsulates data that describes an action.
@@ -49,8 +48,7 @@
             DocAction,  ///< Start a custom action
             Sound,      ///< Play a sound
             Movie,      ///< Play a movie
-            Script,     ///< Executes a Script code
-            ResetForm   ///< Start a reset form action @since 0.14 (KDE 4.8)
+            Script      ///< Executes a Script code
         };
 
         /**
@@ -433,55 +431,6 @@
 };
 #endif
 
-/**
- * The ResetFormAction action resets forms on activation
- * @since 0.14 (KDE 4.8)
- */
-class OKULAR_EXPORT ResetFormAction : public Action
-{
-    public:
-        enum Behaviour
-        {
-            ResetAllForms,                  ///< Reset all the forms in the document
-            ResetFormsInFieldList,          ///< Reset the forms whose fully qualified name is in the list
-            ResetAllFormsExceptFieldList    ///< Reset all the forms in the document exect those whose fully qualified name is in the list
-        };
-
-        /**
-         * Creates a new reset form action.
-         */
-        ResetFormAction( const QStringList &fieldList, Behaviour behaviour );
-
-        /**
-         * Destroys the document action.
-         */
-        virtual ~ResetFormAction();
-        
-        /**
-         * Returns the action type.
-         */
-        ActionType actionType() const;
-
-        /**
-         * Returns the action tip.
-         */
-        QString actionTip() const;
-
-        /**
-         * Returns the reset behaviour.
-         */
-        Behaviour behaviour() const;
-        
-        /**
-         * Returns the list of field fully qualified names.
-         */
-        QStringList fieldList() const;
-
-    private:
-        Q_DECLARE_PRIVATE( ResetFormAction )
-        Q_DISABLE_COPY( ResetFormAction )
-};
-
 }
 
 #endif

=== modified file 'core/document.cpp'
--- core/document.cpp	2011-12-14 13:28:07 +0000
+++ core/document.cpp	2011-12-23 22:53:33 +0000
@@ -78,7 +78,6 @@
 #include "utils_p.h"
 #include "view.h"
 #include "view_p.h"
-#include "form.h"
 
 #include <memory>
 
@@ -3003,55 +3002,6 @@
             //const MovieAction * movie = static_cast< const MovieAction * >( action );
             // TODO this (Movie action)
             break;
-
-        case Action::ResetForm: {
-            const ResetFormAction *resetFormAction = static_cast< const ResetFormAction * >( action );
-            foreach( Page *page, d->m_pagesVector )
-            {
-                foreach( FormField* ff, page->formFields() )
-                {
-                    bool reset = false;
-                    switch (resetFormAction->behaviour())
-                    {
-                        case ResetFormAction::ResetAllForms: 
-                            reset = true;
-                        break;
-                        case ResetFormAction::ResetFormsInFieldList: 
-                            reset = resetFormAction->fieldList().contains(ff->fullyQualifiedName());
-                        break;
-                        case ResetFormAction::ResetAllFormsExceptFieldList: 
-                            reset = !resetFormAction->fieldList().contains(ff->fullyQualifiedName());
-                        break;
-                    }
-                    
-                    if (reset)
-                    {
-                        switch (ff->type()) {
-                            case Okular::FormField::FormText: {
-                                Okular::FormFieldText* fft = static_cast<Okular::FormFieldText *>(ff);
-                                if (!fft->isReadOnly()) {
-                                    fft->setText( fft->defaultValue() );
-                                    emit formFieldChanged(fft);
-                                }
-                            } break;
-        
-                            case Okular::FormField::FormButton: {
-                                Okular::FormFieldButton* ffb = static_cast<Okular::FormFieldButton *>(ff);
-
-                                if (!ffb->isReadOnly()) {
-                                    ffb->setState( "true" == ffb->defaultValue() );
-                                    emit formFieldChanged(ffb);
-                                }
-                            } break;
-                            
-                            default:
-                                kDebug() << "Unhandled form field: " << ff->name() << ff->defaultValue();
-                            break;
-                        }
-                    }
-                }
-            }
-            } break;
     }
 }
 

=== modified file 'core/document.h'
--- core/document.h	2011-12-14 13:28:07 +0000
+++ core/document.h	2011-12-23 22:53:33 +0000
@@ -43,7 +43,6 @@
 class EmbeddedFile;
 class ExportFormat;
 class FontInfo;
-class FormField;
 class Generator;
 class Action;
 class Page;
@@ -723,12 +722,6 @@
          * Reports that the current search finished
          */
         void searchFinished( int id, Okular::Document::SearchStatus endStatus );
-        
-        /**
-         * Reports that some data of the given form changed
-         * @since 0.14 (KDE 4.8)
-         */
-        void formFieldChanged( Okular::FormField *formField );
 
         /**
          * This signal is emitted whenever a source reference with the given parameters has been

=== modified file 'core/form.cpp'
--- core/form.cpp	2011-12-14 13:28:07 +0000
+++ core/form.cpp	2011-12-23 22:53:33 +0000
@@ -50,12 +50,6 @@
     return d->m_type;
 }
 
-QString FormField::defaultValue() const
-{
-    Q_D( const FormField );
-    return d->m_default;
-}
-
 bool FormField::isReadOnly() const
 {
     return false;
@@ -72,12 +66,6 @@
     return d->m_activateAction;
 }
 
-QString FormField::fullyQualifiedName() const
-{
-    Q_D( const FormField );
-    return d->m_fullyQualifiedName;
-}
-
 void FormField::setActivationAction( Action *action )
 {
     Q_D( FormField );
@@ -85,11 +73,6 @@
     d->m_activateAction = action;
 }
 
-void FormField::setFullyQualifiedName( const QString &name )
-{
-    Q_D( FormField );
-    d->m_fullyQualifiedName = name;
-}
 
 class Okular::FormFieldButtonPrivate : public Okular::FormFieldPrivate
 {

=== modified file 'core/form.h'
--- core/form.h	2011-12-14 13:28:07 +0000
+++ core/form.h	2011-12-23 22:53:33 +0000
@@ -60,12 +60,6 @@
         FieldType type() const;
 
         /**
-         * The field default value.
-         * @since 0.14 (KDE 4.8)
-         */
-        QString defaultValue() const;
-
-        /**
          * The bouding rect of the field, in normalized coordinates.
          */
         virtual NormalizedRect rect() const = 0;
@@ -98,12 +92,6 @@
         virtual bool isVisible() const;
 
         Action* activationAction() const;
-        
-        /**
-         * The internal fully qualified name of the field
-         * @since 0.14 (KDE 4.8)
-         */
-        QString fullyQualifiedName() const;
 
     protected:
         /// @cond PRIVATE
@@ -113,8 +101,6 @@
         /// @endcond
 
         void setActivationAction( Action *action );
-        /// @since 0.14 (KDE 4.8)
-        void setFullyQualifiedName( const QString &name );
 
     private:
         Q_DISABLE_COPY( FormField )

=== modified file 'core/form_p.h'
--- core/form_p.h	2011-12-14 13:28:07 +0000
+++ core/form_p.h	2011-12-23 22:53:33 +0000
@@ -33,7 +33,6 @@
         FormField::FieldType m_type;
         QString m_default;
         Action *m_activateAction;
-        QString m_fullyQualifiedName;
 
         Q_DECLARE_PUBLIC( FormField )
         FormField *q_ptr;

=== modified file 'core/textpage.cpp'
--- core/textpage.cpp	2011-12-14 13:28:07 +0000
+++ core/textpage.cpp	2011-12-23 22:53:33 +0000
@@ -39,11 +39,6 @@
         int offset_end;
 };
 
-static int qHash(const QRect &r)
-{
-    return r.left() * r.top() + r.right() * r.bottom();
-}
-
 /* text comparison functions */
 
 bool CaseInsensitiveCmpFn( const QStringRef & from, const QStringRef & to,
@@ -213,10 +208,32 @@
     delete area;
 }
 
+struct WordWithCharacters
+{
+    WordWithCharacters(TinyTextEntity *w, const TextList &c)
+     : word(w), characters(c)
+    {
+    }
+    
+    inline QString text() const
+    {
+        return word->text();
+    }
+    
+    inline const NormalizedRect &area() const
+    {
+      return word->area;
+    }
+    
+    TinyTextEntity *word;
+    TextList characters;
+};
+typedef QList<WordWithCharacters> WordsWithCharacters;
+
 /**
  * We will divide the whole page in some regions depending on the horizontal and
  * vertical spacing among different regions. Each region will have an area and an
- * associated TextList in sorted order.
+ * associated WordsWithCharacters in sorted order.
 */
 class RegionText
 {
@@ -226,22 +243,22 @@
     {
     };
 
-    RegionText(const TextList &list,const QRect &area)
-        : m_region_text(list) ,m_area(area)
+    RegionText(const WordsWithCharacters &wordsWithCharacters, const QRect &area)
+        : m_region_wordWithCharacters(wordsWithCharacters), m_area(area)
     {
     }
     
     inline QString string() const
     {
         QString res;
-        foreach(TinyTextEntity *te, m_region_text)
-            res += te->text();
+        foreach(const WordWithCharacters &word, m_region_wordWithCharacters)
+            res += word.text();
         return res;
     }
 
-    inline TextList text() const
+    inline WordsWithCharacters text() const
     {
-        return m_region_text;
+        return m_region_wordWithCharacters;
     }
 
     inline QRect area() const
@@ -254,13 +271,13 @@
         m_area = area;
     }
 
-    inline void setText(const TextList &text)
+    inline void setText(const WordsWithCharacters &wordsWithCharacters)
     {
-        m_region_text = text;
+        m_region_wordWithCharacters = wordsWithCharacters;
     }
 
 private:
-    TextList m_region_text;
+    WordsWithCharacters m_region_wordWithCharacters;
     QRect m_area;
 };
 
@@ -992,24 +1009,24 @@
     return ret;
 }
 
-static bool compareTinyTextEntityX(TinyTextEntity* first, TinyTextEntity* second)
+static bool compareTinyTextEntityX(const WordWithCharacters &first, const WordWithCharacters &second)
 {
-    QRect firstArea = first->area.roundedGeometry(1000,1000);
-    QRect secondArea = second->area.roundedGeometry(1000,1000);
+    QRect firstArea = first.area().roundedGeometry(1000,1000);
+    QRect secondArea = second.area().roundedGeometry(1000,1000);
 
     return firstArea.left() < secondArea.left();
 }
 
-static bool compareTinyTextEntityY(TinyTextEntity* first, TinyTextEntity* second)
+static bool compareTinyTextEntityY(const WordWithCharacters &first, const WordWithCharacters &second)
 {
-    QRect firstArea = first->area.roundedGeometry(1000,1000);
-    QRect secondArea = second->area.roundedGeometry(1000,1000);
+    const QRect firstArea = first.area().roundedGeometry(1000,1000);
+    const QRect secondArea = second.area().roundedGeometry(1000,1000);
 
     return firstArea.top() < secondArea.top();
 }
 
 /**
- * Copies a TextList to m_words with the same pointer
+ * Sets a new world list. Deleting the contents of the old one
  */
 void TextPagePrivate::setWordList(const TextList &list)
 {
@@ -1018,20 +1035,6 @@
 }
 
 /**
- * Copies from m_words to list with distinct pointers
- */
-TextList TextPagePrivate::duplicateWordList() const
-{
-    TextList list;
-    for(int i = 0 ; i < m_words.length() ; i++)
-    {
-        TinyTextEntity* ent = m_words.at(i);
-        list.append( new TinyTextEntity( ent->text(),ent->area ) );
-    }
-    return list;
-}
-
-/**
  * If the horizontal arm of one rectangle fully contains the other (example below)
  *  --------         ----         -----  first
  *    ----         --------       -----  second
@@ -1093,18 +1096,16 @@
  * Remove all the spaces in between texts. It will make all the generators
  * same, whether they save spaces(like pdf) or not(like djvu).
  */
-void TextPagePrivate::removeSpace()
+static void removeSpace(TextList *words)
 {
-    TextList::Iterator it = m_words.begin(), itEnd = m_words.end();
+    TextList::Iterator it = words->begin(), itEnd = words->end();
     const QString str(' ');
 
-    it = m_words.begin(), itEnd = m_words.end();
     while ( it != itEnd )
     {
         if((*it)->text() == str)
         {
-            delete *it;
-            it = m_words.erase(it);
+            it = words->erase(it);
         }
         else
         {
@@ -1114,36 +1115,29 @@
 }
 
 /**
- * We will the TinyTextEntity from m_words and try to create
- * words from there.
+ * We will read the TinyTextEntity from characters and try to create words from there.
+ * Note: characters might be already characters for some generators, but we will keep
+ * the nomenclature characters for the generator produced data. The resulting
+ * WordsWithCharacters memory has to be managed by the caller, both the 
+ * WordWithCharacters::word and WordWithCharacters::characters contents
  */
-QHash<QRect, RegionText> TextPagePrivate::makeWordFromCharacters()
+static WordsWithCharacters makeWordFromCharacters(const TextList &characters, int pageWidth, int pageHeight)
 {
     /**
-     * At first we will copy m_words to tmpList. Then, we will traverse the
-     * tmpList and try to create words from the TinyTextEntities in tmpList.
+     * We will traverse characters and try to create words from the TinyTextEntities in it.
      * We will search TinyTextEntity blocks and merge them until we get a
      * space between two consecutive TinyTextEntities. When we get a space
      * we can take it as a end of word. Then we store the word as a TinyTextEntity
      * and keep it in newList.
 
-     * We also keep a mapping between every element in newList and word. We create a
-     * RegionText named regionWord and create a hash key from the TinyTextEntity
-     * rectangle area of the element in newList. So, we can get the TinyTextEntities from
-     * which every element(word) of newList is generated. It will be necessary later
-     * when we will divide the word into characters.
+     * We create a RegionText named regionWord that contains the word and the characters associated with it and
+     * a rectangle area of the element in newList. 
 
-     * Finally we copy the newList to m_words.
      */
-
-    QHash<QRect, RegionText> word_chars_map;
-    const TextList tmpList = m_words;
-    TextList newList;
-
-    TextList::ConstIterator it = tmpList.begin(), itEnd = tmpList.end(), tmpIt;
+    WordsWithCharacters wordsWithCharacters;
+
+    TextList::ConstIterator it = characters.begin(), itEnd = characters.end(), tmpIt;
     int newLeft,newRight,newTop,newBottom;
-    const int pageWidth = m_page->m_page->width();
-    const int pageHeight = m_page->m_page->height();
     int index = 0;
 
     for( ; it != itEnd ; it++)
@@ -1151,42 +1145,42 @@
         QString textString = (*it)->text();
         QString newString;
         QRect lineArea = (*it)->area.roundedGeometry(pageWidth,pageHeight),elementArea;
-        TextList word;
+        TextList wordCharacters;
         tmpIt = it;
         int space = 0;
 
-        while(!space )
+        while (!space)
         {
-            if(textString.length())
+            if (textString.length())
             {
                 newString.append(textString);
 
                 // when textString is the start of the word
-                if(tmpIt == it)
+                if (tmpIt == it)
                 {
                     NormalizedRect newRect(lineArea,pageWidth,pageHeight);
-                    word.append(new TinyTextEntity(textString.normalized
+                    wordCharacters.append(new TinyTextEntity(textString.normalized
                                                    (QString::NormalizationForm_KC), newRect));
                 }
                 else
                 {
                     NormalizedRect newRect(elementArea,pageWidth,pageHeight);
-                    word.append(new TinyTextEntity(textString.normalized
+                    wordCharacters.append(new TinyTextEntity(textString.normalized
                                                    (QString::NormalizationForm_KC), newRect));
                 }
             }
 
-            it++;
+            ++it;
 
             /*
              we must have to put this line before the if condition of it==itEnd
              otherwise the last character can be missed
              */
-            if(it == itEnd) break;
+            if (it == itEnd) break;
             elementArea = (*it)->area.roundedGeometry(pageWidth,pageHeight);
-            if(!doesConsumeY(elementArea,lineArea,60))
+            if (!doesConsumeY(elementArea, lineArea, 60))
             {
-                it--;
+                --it;
                 break;
             }
 
@@ -1200,7 +1194,7 @@
 
             space = elementArea.left() - lineArea.right();
 
-            if(space > 0 || space < 0)
+            if (space != 0)
             {
                 it--;
                 break;
@@ -1220,32 +1214,25 @@
         }
 
         // if newString is not empty, save it
-        if(newString.length())
+        if (!newString.isEmpty())
         {
-            const NormalizedRect newRect(lineArea,pageWidth,pageHeight);
-            newList.append(new TinyTextEntity(newString.normalized
-                                              (QString::NormalizationForm_KC), newRect ));
-            const QRect rect = newRect.geometry(pageWidth,pageHeight);
-            const RegionText regionWord(word,rect);
-
-            // there may be more than one element in the same key
-            word_chars_map.insertMulti(rect,regionWord);
+            const NormalizedRect newRect(lineArea, pageWidth, pageHeight);
+            TinyTextEntity *word = new TinyTextEntity(newString.normalized(QString::NormalizationForm_KC), newRect);
+            wordsWithCharacters.append(WordWithCharacters(word, wordCharacters));
 
             index++;
         }
 
         if(it == itEnd) break;
     }
-
-    setWordList(newList);
-
-    return word_chars_map;
+    
+    return wordsWithCharacters;
 }
 
 /**
  * Create Lines from the words and sort them
  */
-void TextPagePrivate::makeAndSortLines(const TextList &wordsTmp, SortedTextList *lines, LineRect *line_rects)
+QList< QPair<WordsWithCharacters, QRect> > makeAndSortLines(const WordsWithCharacters &wordsTmp, int pageWidth, int pageHeight)
 {
     /**
      * We cannot assume that the generator will give us texts in the right order.
@@ -1257,39 +1244,34 @@
      * 2. Create textline where there is y overlap between TinyTextEntity 's
      * 3. Within each line sort the TinyTextEntity 's by x0(left)
      */
+    
+    QList< QPair<WordsWithCharacters, QRect> > lines;
 
     /*
      Make a new copy of the TextList in the words, so that the wordsTmp and lines do
      not contain same pointers for all the TinyTextEntity.
      */
-    TextList words;
-    for(int i = 0 ; i < wordsTmp.length() ; i++)
-    {
-        TinyTextEntity* ent = wordsTmp.at(i);
-        words.append( new TinyTextEntity( ent->text(),ent->area ) );
-    }
+    QList<WordWithCharacters> words = wordsTmp;
 
     // Step 1
     qSort(words.begin(),words.end(),compareTinyTextEntityY);
 
     // Step 2
-    TextList::Iterator it = words.begin(), itEnd = words.end();
-    const int pageWidth = m_page->m_page->width();
-    const int pageHeight = m_page->m_page->height();
+    QList<WordWithCharacters>::Iterator it = words.begin(), itEnd = words.end();
 
     //for every non-space texts(characters/words) in the textList
     for( ; it != itEnd ; it++)
     {
-        const QRect elementArea = (*it)->area.roundedGeometry(pageWidth,pageHeight);
+        const QRect elementArea = (*it).area().roundedGeometry(pageWidth,pageHeight);
         bool found = false;
 
-        for( int i = 0 ; i < lines->length() ; i++)
+        for( int i = 0 ; i < lines.length() ; i++)
         {
             /* the line area which will be expanded
                line_rects is only necessary to preserve the topmin and bottommax of all
                the texts in the line, left and right is not necessary at all
             */
-            QRect &lineArea = (*line_rects)[i];
+            QRect &lineArea = lines[i].second;
             const int text_y1 = elementArea.top() ,
                       text_y2 = elementArea.top() + elementArea.height() ,
                       text_x1 = elementArea.left(),
@@ -1305,7 +1287,7 @@
              */
             if(doesConsumeY(elementArea,lineArea,70))
             {
-                TextList &line = (*lines)[i];
+                WordsWithCharacters &line = lines[i].first;
                 line.append(*it);
 
                 const int newLeft = line_x1 < text_x1 ? line_x1 : text_x1;
@@ -1325,25 +1307,26 @@
          */
         if(!found)
         {
-            TextList tmp;
+            WordsWithCharacters tmp;
             tmp.append((*it));
-            lines->append(tmp);
-            line_rects->append(elementArea);
+            lines.append(QPair<WordsWithCharacters, QRect>(tmp, elementArea));
         }
     }
 
     // Step 3
-    for(int i = 0 ; i < lines->length() ; i++)
+    for(int i = 0 ; i < lines.length() ; i++)
     {
-        TextList &list = (*lines)[i];
-        qSort(list.begin(),list.end(),compareTinyTextEntityX);
+        WordsWithCharacters &list = lines[i].first;
+        qSort(list.begin(), list.end(), compareTinyTextEntityX);
     }
+    
+    return lines;
 }
 
 /**
  * Calculate Statistical information from the lines we made previously
  */
-void TextPagePrivate::calculateStatisticalInformation(const SortedTextList &lines, const LineRect &line_rects, int *word_spacing, int *line_spacing, int *col_spacing)
+static void calculateStatisticalInformation(const QList<WordWithCharacters> &words, int pageWidth, int pageHeight, int *word_spacing, int *line_spacing, int *col_spacing)
 {
     /**
      * For the region, defined by line_rects and lines
@@ -1351,17 +1334,22 @@
      * 2. Make character statistical analysis to differentiate between
      *   word spacing and column spacing.
      */
+    
+    /**
+     * Step 0
+     */
+    const QList< QPair<WordsWithCharacters, QRect> > sortedLines = makeAndSortLines(words, pageWidth, pageHeight);
 
     /**
      * Step 1
      */
     QMap<int,int> line_space_stat;
-    for(int i = 0 ; i < line_rects.length(); i++)
+    for(int i = 0 ; i < sortedLines.length(); i++)
     {
-        const QRect rectUpper = line_rects.at(i);
+        const QRect rectUpper = sortedLines.at(i).second;
 
-        if(i+1 == line_rects.length()) break;
-        const QRect rectLower = line_rects.at(i+1);
+        if(i+1 == sortedLines.length()) break;
+        const QRect rectLower = sortedLines.at(i+1).second;
 
         int linespace = rectLower.top() - (rectUpper.top() + rectUpper.height());
         if(linespace < 0) linespace =-linespace;
@@ -1393,27 +1381,25 @@
     QList< QList<QRect> > space_rects;
     QList<QRect> max_hor_space_rects;
 
-    int pageWidth = m_page->m_page->width(), pageHeight = m_page->m_page->height();
-
     // Space in every line
-    for(int i = 0 ; i < lines.length() ; i++)
+    for(int i = 0 ; i < sortedLines.length() ; i++)
     {
-        TextList list = lines.at(i);
+        const WordsWithCharacters list = sortedLines.at(i).first;
         QList<QRect> line_space_rects;
         int maxSpace = 0, minSpace = pageWidth;
 
         // for every TinyTextEntity element in the line
-        TextList::Iterator it = list.begin(), itEnd = list.end();
+        WordsWithCharacters::ConstIterator it = list.begin(), itEnd = list.end();
         QRect max_area1,max_area2;
         QString before_max, after_max;
 
         // for every line
         for( ; it != itEnd ; it++ )
         {
-            const QRect area1 = (*it)->area.roundedGeometry(pageWidth,pageHeight);
+            const QRect area1 = (*it).area().roundedGeometry(pageWidth,pageHeight);
             if( it+1 == itEnd ) break;
 
-            const QRect area2 = (*(it+1))->area.roundedGeometry(pageWidth,pageHeight);
+            const QRect area2 = (*(it+1)).area().roundedGeometry(pageWidth,pageHeight);
             int space = area2.left() - area1.right();
 
             if(space > maxSpace)
@@ -1421,8 +1407,8 @@
                 max_area1 = area1;
                 max_area2 = area2;
                 maxSpace = space;
-                before_max = (*it)->text();
-                after_max = (*(it+1))->text();
+                before_max = (*it).text();
+                after_max = (*(it+1)).text();
             }
 
             if(space < minSpace && space != 0) minSpace = space;
@@ -1505,27 +1491,25 @@
     *col_spacing = col_space_stat.key(*col_spacing);
 
     // if there is just one line in a region, there is no point in dividing it
-    if(lines.length() == 1)
+    if(sortedLines.length() == 1)
         *word_spacing = *col_spacing;
 }
 
 /**
  * Implements the XY Cut algorithm for textpage segmentation
+ * The resulting RegionTextList will contain RegionText whose WordsWithCharacters::word and
+ * WordsWithCharacters::characters are reused from wordsWithCharacters (i.e. no new nor delete happens in this function)
  */
-RegionTextList TextPagePrivate::XYCutForBoundingBoxes(int tcx, int tcy)
+static RegionTextList XYCutForBoundingBoxes(const QList<WordWithCharacters> &wordsWithCharacters, const NormalizedRect &boundingBox, int pageWidth, int pageHeight)
 {
-    const int pageWidth = m_page->m_page->width();
-    const int pageHeight = m_page->m_page->height();
     RegionTextList tree;
-    QRect contentRect(m_page->m_page->boundingBox().geometry(pageWidth,pageHeight));
-    const TextList words = duplicateWordList();
-    const RegionText root(words,contentRect);
+    QRect contentRect(boundingBox.geometry(pageWidth,pageHeight));
+    const RegionText root(wordsWithCharacters, contentRect);
 
     // start the tree with the root, it is our only region at the start
     tree.push_back(root);
 
-    int i = 0, j, k;
-    int countLoop = 0;
+    int i = 0;
 
     // while traversing the tree has not been ended
     while(i < tree.length())
@@ -1537,69 +1521,57 @@
          * 1. calculation of projection profiles
          */
         // allocate the size of proj profiles and initialize with 0
-        int size_proj_y = node.area().height() ;
-        int size_proj_x = node.area().width() ;
+        int size_proj_y = node.area().height();
+        int size_proj_x = node.area().width();
         //dynamic memory allocation
         QVarLengthArray<int> proj_on_xaxis(size_proj_x);
         QVarLengthArray<int> proj_on_yaxis(size_proj_y);
 
-        for( j = 0 ; j < size_proj_y ; j++ ) proj_on_yaxis[j] = 0;
-        for( j = 0 ; j < size_proj_x ; j++ ) proj_on_xaxis[j] = 0;
+        for( int j = 0 ; j < size_proj_y ; ++j ) proj_on_yaxis[j] = 0;
+        for( int j = 0 ; j < size_proj_x ; ++j ) proj_on_xaxis[j] = 0;
 
-        TextList list = node.text();
+        const QList<WordWithCharacters> list = node.text();
 
         // Calculate tcx and tcy locally for each new region
-        if(countLoop++)
-        {
-            SortedTextList lines;
-            LineRect line_rects;
-            int word_spacing, line_spacing, column_spacing;
-
-            makeAndSortLines(list, &lines, &line_rects);
-            calculateStatisticalInformation(lines, line_rects, &word_spacing, &line_spacing, &column_spacing);
-            for(int i = 0 ; i < lines.length() ; i++)
-            {
-                qDeleteAll(lines.at(i));
-            }   
-            lines.clear();
-
-            tcx = word_spacing * 2;
-            tcy = line_spacing * 2;
-        }
+        int word_spacing, line_spacing, column_spacing;
+        calculateStatisticalInformation(list, pageWidth, pageHeight, &word_spacing, &line_spacing, &column_spacing);
+
+        const int tcx = word_spacing * 2;
+        const int tcy = line_spacing * 2;
 
         int maxX = 0 , maxY = 0;
-        int avgX = 0 ;
+        int avgX = 0;
         int count;
 
         // for every text in the region
-        for( j = 0 ; j < list.length() ; j++ )
+        for(int j = 0 ; j < list.length() ; ++j )
         {
-            TinyTextEntity *ent = list.at(j);
-            QRect entRect = ent->area.geometry(pageWidth,pageHeight);
+            TinyTextEntity *ent = list.at(j).word;
+            const QRect entRect = ent->area.geometry(pageWidth, pageHeight);
 
             // calculate vertical projection profile proj_on_xaxis1
-            for(k = entRect.left() ; k <= entRect.left() + entRect.width() ; k++)
+            for(int k = entRect.left() ; k <= entRect.left() + entRect.width() ; ++k)
             {
                 if( ( k-regionRect.left() ) < size_proj_x && ( k-regionRect.left() ) >= 0 )
                     proj_on_xaxis[k - regionRect.left()] += entRect.height();
             }
 
             // calculate horizontal projection profile in the same way
-            for(k = entRect.top() ; k <= entRect.top() + entRect.height() ; k++)
+            for(int k = entRect.top() ; k <= entRect.top() + entRect.height() ; ++k)
             {
                 if( ( k-regionRect.top() ) < size_proj_y && ( k-regionRect.top() ) >= 0 )
                     proj_on_yaxis[k - regionRect.top()] += entRect.width();
             }
         }
 
-        for( j = 0 ; j < size_proj_y ; j++ )
+        for( int j = 0 ; j < size_proj_y ; ++j )
         {
             if (proj_on_yaxis[j] > maxY)
                 maxY = proj_on_yaxis[j];
         }
 
         avgX = count = 0;
-        for( j = 0 ; j < size_proj_x ; j++ )
+        for( int j = 0 ; j < size_proj_x ; ++j )
         {
             if(proj_on_xaxis[j] > maxX) maxX = proj_on_xaxis[j];
             if(proj_on_xaxis[j])
@@ -1633,9 +1605,9 @@
         regionRect.setBottom(old_top + yend);
 
         int tnx = (int)((double)avgX * 10.0 / 100.0 + 0.5), tny = 0;
-        for( j = 0 ; j < size_proj_x ; j++ )
+        for( int j = 0 ; j < size_proj_x ; ++j )
             proj_on_xaxis[j] -= tnx;
-        for(j = 0 ; j < size_proj_y ; j++)
+        for( int j = 0 ; j < size_proj_y ; ++j )
             proj_on_yaxis[j] -= tny;
 
         /**
@@ -1645,7 +1617,7 @@
         int begin = -1, end = -1;
 
         // find all hor_gaps and find the maximum between them
-        for(j = 1 ; j < size_proj_y ; j++)
+        for(int j = 1 ; j < size_proj_y ; ++j)
         {
             //transition from white to black
             if(begin >= 0 && proj_on_yaxis[j-1] <= 0
@@ -1670,7 +1642,7 @@
         int gap_ver = -1, pos_ver = -1;
 
         //find all the ver_gaps and find the maximum between them
-        for(j = 1 ; j < size_proj_x ; j++)
+        for(int j = 1 ; j < size_proj_x ; ++j)
         {
             //transition from white to black
             if(begin >= 0 && proj_on_xaxis[j-1] <= 0
@@ -1740,22 +1712,20 @@
             continue;
         }
 
-        TextList list1,list2;
-        TinyTextEntity* ent;
-        QRect entRect;
+        WordsWithCharacters list1,list2;
 
         // horizontal cut, topRect and bottomRect
         if(cut_hor)
         {
-            for( j = 0 ; j < list.length() ; j++ )
+            for( int j = 0 ; j < list.length() ; ++j )
             {
-                ent = list.at(j);
-                entRect = ent->area.geometry(pageWidth,pageHeight);
+                const WordWithCharacters word = list.at(j);
+                const QRect wordRect = word.area().geometry(pageWidth,pageHeight);
 
-                if(topRect.intersects(entRect))
-                    list1.append(ent);
+                if(topRect.intersects(wordRect))
+                    list1.append(word);
                 else
-                    list2.append(ent);
+                    list2.append(word);
             }
 
             RegionText node1(list1,topRect);
@@ -1768,14 +1738,15 @@
         //vertical cut, leftRect and rightRect
         else if(cut_ver)
         {
-            for( j = 0 ; j < list.length() ; j++ )
+            for( int j = 0 ; j < list.length() ; ++j )
             {
-                ent = list.at(j);
-                entRect = ent->area.geometry(pageWidth,pageHeight);
+                const WordWithCharacters word = list.at(j);
+                const QRect wordRect = word.area().geometry(pageWidth,pageHeight);
 
-                if(leftRect.intersects(entRect))
-                    list1.append(ent);
-                else list2.append(ent);
+                if(leftRect.intersects(wordRect))
+                    list1.append(word);
+                else 
+                    list2.append(word);
             }
 
             RegionText node1(list1,leftRect);
@@ -1786,52 +1757,38 @@
         }
     }
 
-    TextList tmp;
-    for(i = 0 ; i < tree.length() ; i++)
-    {
-        tmp += tree.at(i).text();
-    }
-    // set tmp as new m_words
-    setWordList(tmp);
-
     return tree;
 }
 
 /**
- * Add spaces in between words in a line
+ * Add spaces in between words in a line. It reuses the pointers passed in tree and might add new ones. You will need to take care of deleting them if needed
  */
-void TextPagePrivate::addNecessarySpace(RegionTextList tree)
+WordsWithCharacters addNecessarySpace(RegionTextList tree, int pageWidth, int pageHeight)
 {
     /**
      * 1. Call makeAndSortLines before adding spaces in between words in a line
      * 2. Now add spaces between every two words in a line
-     * 3. Finally, extract all the space separated texts from each region and
-     *    make m_words nice again.
+     * 3. Finally, extract all the space separated texts from each region and return it
      */
 
-    const int pageWidth = m_page->m_page->width();
-    const int pageHeight = m_page->m_page->height();
-
     // Only change the texts under RegionTexts, not the area
     for(int j = 0 ; j < tree.length() ; j++)
     {
         RegionText &tmpRegion = tree[j];
-        SortedTextList lines;
-        LineRect line_rects;
 
         // Step 01
-        makeAndSortLines(tmpRegion.text(), &lines, &line_rects);
+        QList< QPair<WordsWithCharacters, QRect> > sortedLines = makeAndSortLines(tmpRegion.text(), pageWidth, pageHeight);
 
         // Step 02
-        for(int i = 0 ; i < lines.length() ; i++)
+        for(int i = 0 ; i < sortedLines.length() ; i++)
         {
-            TextList &list = lines[i];
+            WordsWithCharacters &list = sortedLines[i].first;
             for(int k = 0 ; k < list.length() ; k++ )
             {
-                const QRect area1 = list.at(k)->area.roundedGeometry(pageWidth,pageHeight);
+                const QRect area1 = list.at(k).area().roundedGeometry(pageWidth,pageHeight);
                 if( k+1 >= list.length() ) break;
 
-                const QRect area2 = list.at(k+1)->area.roundedGeometry(pageWidth,pageHeight);
+                const QRect area2 = list.at(k+1).area().roundedGeometry(pageWidth,pageHeight);
                 const int space = area2.left() - area1.right();
 
                 if(space != 0)
@@ -1845,9 +1802,11 @@
                     const QString spaceStr(" ");
                     const QRect rect(QPoint(left,top),QPoint(right,bottom));
                     const NormalizedRect entRect(rect,pageWidth,pageHeight);
-                    TinyTextEntity *ent = new TinyTextEntity(spaceStr,entRect);
+                    TinyTextEntity *ent1 = new TinyTextEntity(spaceStr, entRect);
+                    TinyTextEntity *ent2 = new TinyTextEntity(spaceStr, entRect);
+                    WordWithCharacters word(ent1, QList<TinyTextEntity*>() << ent2);
 
-                    list.insert(k+1,ent);
+                    list.insert(k+1, word);
 
                     // Skip the space
                     k++;
@@ -1855,110 +1814,63 @@
             }
         }
 
-        TextList tmpList;
-        for(int i = 0 ; i < lines.length() ; i++)
+        WordsWithCharacters tmpList;
+        for(int i = 0 ; i < sortedLines.length() ; i++)
         {
-            tmpList += lines.at(i);
+            tmpList += sortedLines.at(i).first;
         }
         tmpRegion.setText(tmpList);
     }
 
     // Step 03
-    TextList tmp;
+    WordsWithCharacters tmp;
     for(int i = 0 ; i < tree.length() ; i++)
     {
         tmp += tree.at(i).text();
     }
-    setWordList(tmp);
-}
-
-/**
- * Break Words into Characters, takes Entities from m_words and for each of
- * them insert the character entities in tmp. Finally, copies tmp back to m_words
- */
-void TextPagePrivate::breakWordIntoCharacters(const QHash<QRect, RegionText> &word_chars_map)
-{
-    const QString spaceStr(" ");
-    TextList tmp;
-    const int pageWidth = m_page->m_page->width();
-    const int pageHeight = m_page->m_page->height();
-
-    for(int i = 0 ; i < m_words.length() ; i++)
-    {
-        TinyTextEntity *ent = m_words.at(i);
-        const QRect rect = ent->area.geometry(pageWidth,pageHeight);
-
-        // the spaces contains only one character, so we can skip them
-        if(ent->text() == spaceStr)
-            tmp.append( new TinyTextEntity(ent->text(),ent->area) );
-        else
-        {
-            RegionText word_text;
-
-            QHash<QRect, RegionText>::const_iterator it = word_chars_map.find(rect);
-            while( it != word_chars_map.end() && it.key() == rect )
-            {
-                word_text = it.value();
-                    
-                if (ent->text() == word_text.string())
-                    break;
-                    
-                ++it;
-            }
-            tmp.append(word_text.text());
-        }
-    }
-    setWordList(tmp);
-}
-
+    return tmp;
+}
 
 /**
  * Correct the textOrder, all layout recognition works here
  */
 void TextPagePrivate::correctTextOrder()
 {
+    const int pageWidth = m_page->m_page->width();
+    const int pageHeight = m_page->m_page->height();
+
+    TextList characters = m_words;
+
     /**
      * Remove spaces from the text
      */
-    removeSpace();
+    removeSpace(&characters);
 
     /**
      * Construct words from characters
      */
-    const QHash<QRect, RegionText> word_chars_map = makeWordFromCharacters();
-
-    SortedTextList lines;
-    LineRect line_rects;
-    /**
-     * Create arbitrary lines from words and sort them according to X and Y position
-     */
-    makeAndSortLines(m_words, &lines, &line_rects);
-
-    /**
-     * Calculate statistical information which will be needed later for algorithm implementation
-     */
-    int word_spacing, line_spacing, col_spacing;
-    calculateStatisticalInformation(lines, line_rects, &word_spacing, &line_spacing, &col_spacing);
-    for(int i = 0 ; i < lines.length() ; i++)
-    {
-       qDeleteAll(lines.at(i));
-    }
-    lines.clear();
+    const QList<WordWithCharacters> wordsWithCharacters = makeWordFromCharacters(characters, pageWidth, pageHeight);
 
     /**
      * Make a XY Cut tree for segmentation of the texts
      */
-    const RegionTextList tree = XYCutForBoundingBoxes(word_spacing * 2, line_spacing * 2);
+    const RegionTextList tree = XYCutForBoundingBoxes(wordsWithCharacters, m_page->m_page->boundingBox(), pageWidth, pageHeight);
 
     /**
      * Add spaces to the word
      */
-    addNecessarySpace(tree);
+    const WordsWithCharacters listWithWordsAndSpaces = addNecessarySpace(tree, pageWidth, pageHeight);
 
     /**
      * Break the words into characters
      */
-    breakWordIntoCharacters(word_chars_map);
+    TextList listOfCharacters;
+    foreach(const WordWithCharacters &word, listWithWordsAndSpaces)
+    {
+        delete word.word;
+        listOfCharacters.append(word.characters);
+    }
+    setWordList(listOfCharacters);
 }
 
 TextEntity::List TextPage::words(const RegularAreaRect *area, TextAreaInclusionBehaviour b) const

=== modified file 'core/textpage_p.h'
--- core/textpage_p.h	2011-12-14 13:28:07 +0000
+++ core/textpage_p.h	2011-12-23 22:53:33 +0000
@@ -13,6 +13,7 @@
 
 #include <QtCore/QList>
 #include <QtCore/QMap>
+#include <QtCore/QPair>
 #include <QtGui/QMatrix>
 
 class SearchPoint;
@@ -29,12 +30,6 @@
                                           int *fromLength, int *toLength );
 
 /**
- * Make a line of TextList and store the bounding rectangle of line
- */
-typedef QList<TextList> SortedTextList;
-typedef QList<QRect> LineRect;
-
-/**
  * A list of RegionText. It keeps a bunch of TextList with their bounding rectangles
  */
 typedef QList<RegionText> RegionTextList;
@@ -62,55 +57,11 @@
         void setWordList(const TextList &list);
 
         /**
-         * Copy m_words to a new TextList, it is the caller responsability to free the pointers
-         */
-        TextList duplicateWordList() const;
-
-        /**
          * Make necessary modifications in the TextList to make the text order correct, so
          * that textselection works fine
          */
         void correctTextOrder();
 
-        /**
-         * Remove odd spaces which are much bigger than normal spaces from m_words
-         */
-        void removeSpace();
-
-        /**
-         * Create words from characters
-         */
-        QHash<QRect, RegionText> makeWordFromCharacters();
-
-        /**
-         * Create lines from TextList and sort them according to their position
-         */
-        void makeAndSortLines(const TextList &words, SortedTextList *lines, LineRect *line_rects);
-
-        /**
-         * Caluclate statistical info like, word spacing, column spacing, line spacing from the Lines
-         * we made
-         */
-        void calculateStatisticalInformation(const SortedTextList &lines, const LineRect &line_rects, int *word_spacing,
-                                             int *line_spacing, int *column_spacing);
-
-        /**
-         * Functions necessary for document file segmentation into text regions for document layout
-         * analysis.
-         */
-        RegionTextList XYCutForBoundingBoxes(int tcx, int tcy);
-
-        /**
-         * Add additional spaces between words, if necessary, which can make the words valuable
-         * while copying after selection
-         */
-        void addNecessarySpace(RegionTextList tree);
-
-        /**
-         * Break the words into characters, so the text selection wors fine
-         */
-        void breakWordIntoCharacters(const QHash<QRect, RegionText> &words_char_map);
-
         // variables those can be accessed directly from TextPage
         TextList m_words;
         QMap< int, SearchPoint* > m_searchPoints;

=== modified file 'doc/index.cache.bz2'
Binary files doc/index.cache.bz2 and doc/index.cache.bz2 differ
=== modified file 'generators/chm/okularApplication_chm.desktop'
--- generators/chm/okularApplication_chm.desktop	2011-09-02 21:34:01 +0000
+++ generators/chm/okularApplication_chm.desktop	2011-12-23 22:53:33 +0000
@@ -127,3 +127,22 @@
 Categories=Qt;KDE;Graphics;Viewer;
 NoDisplay=true
 X-KDE-Keywords=chm
+X-KDE-Keywords[ca]=chm
+X-KDE-Keywords[cs]=chm
+X-KDE-Keywords[de]=chm
+X-KDE-Keywords[es]=chm
+X-KDE-Keywords[fr]=chm
+X-KDE-Keywords[hu]=chm
+X-KDE-Keywords[it]=chm
+X-KDE-Keywords[kk]=chm
+X-KDE-Keywords[nb]=chm
+X-KDE-Keywords[nds]=CHM
+X-KDE-Keywords[nl]=chm
+X-KDE-Keywords[pa]=chm
+X-KDE-Keywords[pt]=chm
+X-KDE-Keywords[pt_BR]=chm
+X-KDE-Keywords[sk]=chm
+X-KDE-Keywords[sv]=chm
+X-KDE-Keywords[uk]=chm
+X-KDE-Keywords[x-test]=xxchmxx
+X-KDE-Keywords[zh_TW]=chm

=== modified file 'generators/comicbook/okularApplication_comicbook.desktop'
--- generators/comicbook/okularApplication_comicbook.desktop	2011-09-02 21:34:01 +0000
+++ generators/comicbook/okularApplication_comicbook.desktop	2011-12-23 22:53:33 +0000
@@ -127,3 +127,21 @@
 Categories=Qt;KDE;Graphics;Viewer;
 NoDisplay=true
 X-KDE-Keywords=cbr, cbz, cbt, Comic Book
+X-KDE-Keywords[ca]=cbr, cbz, cbt, Comic Book
+X-KDE-Keywords[cs]=cbr, cbz, cbt, Comic Book
+X-KDE-Keywords[de]=cbr, cbz, cbt, Comic Book
+X-KDE-Keywords[es]=cbr, cbz, cbt, libro de cómic
+X-KDE-Keywords[fr]=cbr, cbz, cbt, Comic Book
+X-KDE-Keywords[hu]=cbr, cbz, cbt, Képregény
+X-KDE-Keywords[kk]=cbr, cbz, cbt, Comic Book
+X-KDE-Keywords[nb]=cbr, cbz, cbt, tegneserie
+X-KDE-Keywords[nds]=cbr, cbz, cbt, Comicbook
+X-KDE-Keywords[nl]=cbr, cbz, cbt, Stripverhaal
+X-KDE-Keywords[pa]=cbr, cbz, cbt, ਕਾਮਿਕ ਬੁੱਕ
+X-KDE-Keywords[pt]=cbr, cbz, cbt, Comic Book
+X-KDE-Keywords[pt_BR]=cbr, cbz, cbt, Comic Book
+X-KDE-Keywords[sk]=cbr, cbz, cbt, Comic Book, Kniha komiksov
+X-KDE-Keywords[sv]=cbr, cbz, cbt, Comic Book
+X-KDE-Keywords[uk]=cbr,cbz,cbt,Comic Book,комікс
+X-KDE-Keywords[x-test]=xxcbr, cbz, cbt, Comic Bookxx
+X-KDE-Keywords[zh_TW]=cbr, cbz, cbt, Comic Book

=== modified file 'generators/djvu/okularApplication_djvu.desktop'
--- generators/djvu/okularApplication_djvu.desktop	2011-09-02 21:34:01 +0000
+++ generators/djvu/okularApplication_djvu.desktop	2011-12-23 22:53:33 +0000
@@ -127,3 +127,22 @@
 Categories=Qt;KDE;Graphics;Viewer;
 NoDisplay=true
 X-KDE-Keywords=djvu
+X-KDE-Keywords[ca]=djvu
+X-KDE-Keywords[cs]=djvu
+X-KDE-Keywords[de]=djvu
+X-KDE-Keywords[es]=djvu
+X-KDE-Keywords[fr]=djvu
+X-KDE-Keywords[hu]=djvu
+X-KDE-Keywords[it]=djvu
+X-KDE-Keywords[kk]=djvu
+X-KDE-Keywords[nb]=djvu
+X-KDE-Keywords[nds]=DjVu
+X-KDE-Keywords[nl]=djvu
+X-KDE-Keywords[pa]=djvu
+X-KDE-Keywords[pt]=djvu
+X-KDE-Keywords[pt_BR]=djvu
+X-KDE-Keywords[sk]=djvu
+X-KDE-Keywords[sv]=djvu
+X-KDE-Keywords[uk]=djvu
+X-KDE-Keywords[x-test]=xxdjvuxx
+X-KDE-Keywords[zh_TW]=djvu

=== modified file 'generators/dvi/okularApplication_dvi.desktop'
--- generators/dvi/okularApplication_dvi.desktop	2011-09-02 21:34:01 +0000
+++ generators/dvi/okularApplication_dvi.desktop	2011-12-23 22:53:33 +0000
@@ -127,3 +127,22 @@
 Categories=Qt;KDE;Graphics;Viewer;
 NoDisplay=true
 X-KDE-Keywords=dvi
+X-KDE-Keywords[ca]=dvi
+X-KDE-Keywords[cs]=dvi
+X-KDE-Keywords[de]=dvi
+X-KDE-Keywords[es]=dvi
+X-KDE-Keywords[fr]=dvi
+X-KDE-Keywords[hu]=dvi
+X-KDE-Keywords[it]=dvi
+X-KDE-Keywords[kk]=dvi
+X-KDE-Keywords[nb]=dvi
+X-KDE-Keywords[nds]=DVI
+X-KDE-Keywords[nl]=dvi
+X-KDE-Keywords[pa]=dvi
+X-KDE-Keywords[pt]=dvi
+X-KDE-Keywords[pt_BR]=dvi
+X-KDE-Keywords[sk]=dvi
+X-KDE-Keywords[sv]=dvi
+X-KDE-Keywords[uk]=dvi
+X-KDE-Keywords[x-test]=xxdvixx
+X-KDE-Keywords[zh_TW]=dvi

=== modified file 'generators/epub/okularApplication_epub.desktop'
--- generators/epub/okularApplication_epub.desktop	2011-09-02 21:34:01 +0000
+++ generators/epub/okularApplication_epub.desktop	2011-12-23 22:53:33 +0000
@@ -127,3 +127,22 @@
 Categories=Qt;KDE;Graphics;Viewer;
 NoDisplay=true
 X-KDE-Keywords=epub, e-book
+X-KDE-Keywords[ca]=epub, e-book
+X-KDE-Keywords[cs]=epub, e-book
+X-KDE-Keywords[de]=epub, e-book
+X-KDE-Keywords[es]=epub, e-book
+X-KDE-Keywords[fr]=epub, e-book
+X-KDE-Keywords[hu]=epub, e-book
+X-KDE-Keywords[it]=epub, e-book
+X-KDE-Keywords[kk]=epub, e-book
+X-KDE-Keywords[nb]=epub, e-bok
+X-KDE-Keywords[nds]=epub, e-book
+X-KDE-Keywords[nl]=epub, e-book
+X-KDE-Keywords[pa]=epub, e-book, ਈ-ਬੁੱਕ
+X-KDE-Keywords[pt]=epub, e-book
+X-KDE-Keywords[pt_BR]=epub, e-book
+X-KDE-Keywords[sk]=epub, e-book
+X-KDE-Keywords[sv]=epub, e-bok
+X-KDE-Keywords[uk]=epub,e-book,електронна,книга
+X-KDE-Keywords[x-test]=xxepub, e-bookxx
+X-KDE-Keywords[zh_TW]=epub, e-book

=== modified file 'generators/fictionbook/okularApplication_fb.desktop'
--- generators/fictionbook/okularApplication_fb.desktop	2011-09-02 21:34:01 +0000
+++ generators/fictionbook/okularApplication_fb.desktop	2011-12-23 22:53:33 +0000
@@ -127,3 +127,20 @@
 Categories=Qt;KDE;Graphics;Viewer;
 NoDisplay=true
 X-KDE-Keywords=FictionBook, e-book, fb2
+X-KDE-Keywords[ca]=FictionBook, e-book, fb2
+X-KDE-Keywords[de]=FictionBook, e-book, fb2
+X-KDE-Keywords[es]=FictionBook, e-book, fb2
+X-KDE-Keywords[fr]=FictionBook, e-book, fb2
+X-KDE-Keywords[hu]=FictionBook, e-book, fb2
+X-KDE-Keywords[kk]=FictionBook, e-book, fb2
+X-KDE-Keywords[nb]=FictionBook, e-bok, fb2
+X-KDE-Keywords[nds]=FictionBook, e-book, fb2
+X-KDE-Keywords[nl]=Fictieboek, e-book, fb2
+X-KDE-Keywords[pa]=FictionBook, e-book, fb2
+X-KDE-Keywords[pt]=FictionBook, e-book, fb2
+X-KDE-Keywords[pt_BR]=FictionBook, e-book, fb2
+X-KDE-Keywords[sk]=FictionBook, e-book, fb2
+X-KDE-Keywords[sv]=FictionBook, e-bok, fb2
+X-KDE-Keywords[uk]=FictionBook,fb2,електронна,книга
+X-KDE-Keywords[x-test]=xxFictionBook, e-book, fb2xx
+X-KDE-Keywords[zh_TW]=FictionBook, e-book, fb2

=== modified file 'generators/plucker/okularApplication_plucker.desktop'
--- generators/plucker/okularApplication_plucker.desktop	2011-09-02 21:34:01 +0000
+++ generators/plucker/okularApplication_plucker.desktop	2011-12-23 22:53:33 +0000
@@ -127,3 +127,20 @@
 Categories=Qt;KDE;Graphics;Viewer;
 NoDisplay=true
 X-KDE-Keywords=plucker
+X-KDE-Keywords[ca]=plucker
+X-KDE-Keywords[de]=plucker
+X-KDE-Keywords[es]=plucker
+X-KDE-Keywords[fr]=plucker
+X-KDE-Keywords[hu]=plucker
+X-KDE-Keywords[kk]=plucker
+X-KDE-Keywords[nb]=plucker
+X-KDE-Keywords[nds]=Plucker
+X-KDE-Keywords[nl]=plucker
+X-KDE-Keywords[pa]=ਪਲੱਕਰ
+X-KDE-Keywords[pt]=plucker
+X-KDE-Keywords[pt_BR]=plucker
+X-KDE-Keywords[sk]=plucker
+X-KDE-Keywords[sv]=plucker
+X-KDE-Keywords[uk]=plucker
+X-KDE-Keywords[x-test]=xxpluckerxx
+X-KDE-Keywords[zh_TW]=plucker

=== modified file 'generators/poppler/okularApplication_pdf.desktop'
--- generators/poppler/okularApplication_pdf.desktop	2011-09-02 21:34:01 +0000
+++ generators/poppler/okularApplication_pdf.desktop	2011-12-23 22:53:33 +0000
@@ -126,4 +126,22 @@
 InitialPreference=8
 Categories=Qt;KDE;Graphics;Viewer;
 X-KDE-Keywords=PDF, Portable Document Format
+X-KDE-Keywords[ca]=PDF, Portable Document Format, Format de document portable
+X-KDE-Keywords[cs]=PDF, Portable Document Format
+X-KDE-Keywords[de]=PDF, Portable Document Format
+X-KDE-Keywords[es]=PDF, Formato de Documento Portable
+X-KDE-Keywords[fr]=PDF, Portable Document Format
+X-KDE-Keywords[hu]=PDF, Portable Document Format
+X-KDE-Keywords[kk]=PDF, Portable Document Format
+X-KDE-Keywords[nb]=PDF, Portabelt Dokument Format
+X-KDE-Keywords[nds]=PDF, Porteerbor Dokmentformaat
+X-KDE-Keywords[nl]=PDF, Portable Document Format
+X-KDE-Keywords[pa]=PDF, ਪੋਰਟੇਬਲ ਡੌਕੂਮੈਂਟ ਫਾਰਮੈਟ
+X-KDE-Keywords[pt]=PDF, Formato de Documento Portável
+X-KDE-Keywords[pt_BR]=PDF, Formato de documento portável
+X-KDE-Keywords[sk]=PDF, Portable Document Format
+X-KDE-Keywords[sv]=PDF, Portabelt dokumentformat
+X-KDE-Keywords[uk]=PDF,Portable Document Format,пдф
+X-KDE-Keywords[x-test]=xxPDF, Portable Document Formatxx
+X-KDE-Keywords[zh_TW]=PDF, Portable Document Format
 NoDisplay=true

=== modified file 'generators/xps/okularApplication_xps.desktop'
--- generators/xps/okularApplication_xps.desktop	2011-09-02 21:34:01 +0000
+++ generators/xps/okularApplication_xps.desktop	2011-12-23 22:53:33 +0000
@@ -126,4 +126,22 @@
 InitialPreference=7
 Categories=Qt;KDE;Graphics;Viewer;
 X-KDE-Keywords=XPS
+X-KDE-Keywords[ca]=XPS
+X-KDE-Keywords[cs]=XPS
+X-KDE-Keywords[de]=XPS
+X-KDE-Keywords[es]=XPS
+X-KDE-Keywords[fr]=XPS
+X-KDE-Keywords[hu]=XPS
+X-KDE-Keywords[kk]=XPS
+X-KDE-Keywords[nb]=XPS
+X-KDE-Keywords[nds]=XPS
+X-KDE-Keywords[nl]=XPS
+X-KDE-Keywords[pa]=XPS
+X-KDE-Keywords[pt]=XPS
+X-KDE-Keywords[pt_BR]=XPS
+X-KDE-Keywords[sk]=XPS
+X-KDE-Keywords[sv]=XPS
+X-KDE-Keywords[uk]=XPS
+X-KDE-Keywords[x-test]=xxXPSxx
+X-KDE-Keywords[zh_TW]=XPS
 NoDisplay=true

=== modified file 'interfaces/viewerinterface.h'
--- interfaces/viewerinterface.h	2011-12-14 13:28:07 +0000
+++ interfaces/viewerinterface.h	2011-12-23 22:53:33 +0000
@@ -13,7 +13,7 @@
 #include "../core/okular_export.h"
 
 #include <QtCore/QObject>
-#include <QString>
+#include <QtCore/QString>
 
 namespace Okular {
 

=== modified file 'part.cpp'
--- part.cpp	2011-12-14 13:28:07 +0000
+++ part.cpp	2011-12-23 22:53:33 +0000
@@ -392,14 +392,13 @@
     m_formsMessage->setup( i18n( "This document has forms. Click on the button to interact with them, or use View -> Show Forms." ) );
     rightLayout->addWidget( m_formsMessage );
     m_pageView = new PageView( rightContainer, m_document );
-    m_pageView->setFocus();      //usability setting
+    QMetaObject::invokeMethod( m_pageView, "setFocus", Qt::QueuedConnection );      //usability setting
 //    m_splitter->setFocusProxy(m_pageView);
     connect( m_pageView, SIGNAL(urlDropped(KUrl)), SLOT(openUrlFromDocument(KUrl)));
     connect( m_pageView, SIGNAL(rightClick(const Okular::Page*,QPoint)), this, SLOT(slotShowMenu(const Okular::Page*,QPoint)) );
     connect( m_document, SIGNAL(error(QString,int)), m_pageView, SLOT(errorMessage(QString,int)) );
     connect( m_document, SIGNAL(warning(QString,int)), m_pageView, SLOT(warningMessage(QString,int)) );
     connect( m_document, SIGNAL(notice(QString,int)), m_pageView, SLOT(noticeMessage(QString,int)) );
-    connect( m_document, SIGNAL(formFieldChanged(Okular::FormField*)), m_pageView, SLOT(slotFormFieldChanged(Okular::FormField*)) );
     connect( m_document, SIGNAL(sourceReferenceActivated(const QString&,int,int,bool*)), this, SLOT(slotHandleActivatedSourceReference(const QString&,int,int,bool*)) );
     rightLayout->addWidget( m_pageView );
     m_findBar = new FindBar( m_document, rightContainer );

=== modified file 'ui/pageview.cpp'
--- ui/pageview.cpp	2011-12-14 13:28:07 +0000
+++ ui/pageview.cpp	2011-12-23 22:53:33 +0000
@@ -863,9 +863,11 @@
         // update the mouse cursor when closing because we may have close through a link and
         // want the cursor to come back to the normal cursor
         updateCursor( contentAreaPosition() + viewport()->mapFromGlobal( QCursor::pos() ) );
-        // then, make the message window and scrollbars disappear, which triggers a repaint
+        // then, make the message window and scrollbars disappear, and trigger a repaint
         d->messageWindow->hide();
         resizeContentArea( QSize( 0,0 ) );
+        viewport()->update(); // when there is no change to the scrollbars, no repaint would
+                              // be done and the old document would still be shown
     }
 
     // OSD to display pages
@@ -3638,8 +3640,10 @@
 
     // handle the 'center first page in row' stuff
     int nCols = viewColumns();
-    bool centerFirstPage = Okular::Settings::viewMode() == Okular::Settings::EnumViewMode::FacingFirstCentered;
+    const bool centerFirstPage = Okular::Settings::viewMode() == Okular::Settings::EnumViewMode::FacingFirstCentered;
+    const bool centerLastPage = centerFirstPage && d->items.count() % 2 == 0;
     const bool continuousView = Okular::Settings::viewContinuous();
+    const bool facingPages = centerFirstPage || Okular::Settings::viewMode() == Okular::Settings::EnumViewMode::Facing;
 
     // set all items geometry and resize contents. handle 'continuous' and 'single' modes separately
 
@@ -3721,7 +3725,26 @@
             if ( continuousView || rIdx == pageRowIdx )
             {
                 const bool reallyDoCenterFirst = item->pageNumber() == 0 && centerFirstPage;
-                item->moveTo( (reallyDoCenterFirst ? 0 : insertX) + ( (reallyDoCenterFirst ? fullWidth : cWidth) - item->croppedWidth()) / 2,
+                const bool reallyDoCenterLast = item->pageNumber() == d->items.count() - 1 && centerLastPage;
+                int actualX = 0;
+                if ( reallyDoCenterFirst || reallyDoCenterLast )
+                {
+                    // page is centered across entire viewport
+                    actualX = (fullWidth - item->croppedWidth()) / 2;
+                }
+                else if ( facingPages )
+                {
+                    // page edges 'touch' the center of the viewport
+                    actualX = ( (centerFirstPage && item->pageNumber() % 2 == 1) ||
+                                (!centerFirstPage && item->pageNumber() % 2 == 0) ) ?
+                        (fullWidth / 2) - item->croppedWidth() - 1 : (fullWidth / 2) + 1;
+                }
+                else
+                {
+                    // page is centered within its virtual column
+                    actualX = insertX + (cWidth - item->croppedWidth()) / 2;
+                }
+                item->moveTo( actualX,
                               (continuousView ? insertY : origInsertY) + (rHeight - item->croppedHeight()) / 2 );
                 item->setVisible( true );
             }
@@ -3804,17 +3827,18 @@
          d->mouseMidZooming )
         return;
 
-    // precalc view limits for intersecting with page coords inside the lOOp
-    bool isEvent = newValue != -1 && !d->blockViewport;
-    QRect viewportRect( horizontalScrollBar()->value(),
-                        verticalScrollBar()->value(),
-                        viewport()->width(), viewport()->height() );
+    // precalc view limits for intersecting with page coords inside the loop
+    const bool isEvent = newValue != -1 && !d->blockViewport;
+    const QRect viewportRect( horizontalScrollBar()->value(),
+                              verticalScrollBar()->value(),
+                              viewport()->width(), viewport()->height() );
+    const QRect viewportRectAtZeroZero( 0, 0, viewport()->width(), viewport()->height() );
 
     // some variables used to determine the viewport
     int nearPageNumber = -1;
-    double viewportCenterX = (viewportRect.left() + viewportRect.right()) / 2.0,
-           viewportCenterY = (viewportRect.top() + viewportRect.bottom()) / 2.0,
-           focusedX = 0.5,
+    const double viewportCenterX = (viewportRect.left() + viewportRect.right()) / 2.0;
+    const double viewportCenterY = (viewportRect.top() + viewportRect.bottom()) / 2.0;
+    double focusedX = 0.5,
            focusedY = 0.0,
            minDistance = -1.0;
 
@@ -3839,6 +3863,10 @@
             vw->move(
                 qRound( i->uncroppedGeometry().left() + i->uncroppedWidth() * r.left ) + 1 - viewportRect.left(),
                 qRound( i->uncroppedGeometry().top() + i->uncroppedHeight() * r.top ) + 1 - viewportRect.top() );
+            
+            if ( vw->isPlaying() && viewportRectAtZeroZero.intersect( vw->geometry() ).isEmpty() ) {
+                vw->stop();
+            }
         }
 
         if ( !i->isVisible() )
@@ -4341,40 +4369,6 @@
     d->document->processAction( action );
 }
 
-void PageView::slotFormFieldChanged( Okular::FormField *ff )
-{
-    QVector< PageViewItem * >::const_iterator dIt = d->items.constBegin(), dEnd = d->items.constEnd();
-    for ( ; dIt != dEnd; ++dIt )
-    {
-        FormWidgetIface *fw = (*dIt)->formWidgets().value( ff->id() );
-        if (fw != NULL)
-        {
-            switch (ff->type()) {
-                case Okular::FormField::FormText: {
-                    Okular::FormFieldText* fft = static_cast<Okular::FormFieldText *>(ff);
-                    FormLineEdit *le = dynamic_cast<FormLineEdit *>(fw);
-                    TextAreaEdit *te = dynamic_cast<TextAreaEdit *>(fw);
-
-                    if (le) le->setText( fft->text() );
-                    if (te) te->setText( fft->text() );
-                } break;
-       
-                case Okular::FormField::FormButton: {
-                    Okular::FormFieldButton* ffb = static_cast<Okular::FormFieldButton *>(ff);
-                    QAbstractButton *be = dynamic_cast<QAbstractButton *>(fw);
-                    if (be) be->setChecked( ffb->state() );
-                } break;
-       
-                default:
-                    kDebug() << "Unhandled form field: " << ff->name() << ff->defaultValue();
-                break;
-            }
-            
-            break; // Found the widget, no need to loop more pages
-        }
-    }
-}
-
 void PageView::externalKeyPressEvent( QKeyEvent *e )
 {
     keyPressEvent( e );

=== modified file 'ui/pageview.h'
--- ui/pageview.h	2011-12-14 13:28:07 +0000
+++ ui/pageview.h	2011-12-23 22:53:33 +0000
@@ -37,7 +37,6 @@
 class Document;
 class DocumentViewport;
 class Annotation;
-class FormField;
 }
 
 class FormWidgetIface;
@@ -246,7 +245,6 @@
         void slotSpeakCurrentPage();
         void slotStopSpeaks();
         void slotAction( Okular::Action *action );
-        void slotFormFieldChanged( Okular::FormField *formField );
         void externalKeyPressEvent( QKeyEvent *e );
 };
 

=== modified file 'ui/sidebar.cpp'
--- ui/sidebar.cpp	2011-12-14 13:28:07 +0000
+++ ui/sidebar.cpp	2011-12-23 22:53:33 +0000
@@ -474,6 +474,8 @@
     connect( d->list, SIGNAL(customContextMenuRequested(QPoint)),
              this, SLOT(listContextMenu(QPoint)) );
     connect( d->splitter, SIGNAL(splitterMoved(int,int)), this, SLOT(splitterMoved(int,int)) );
+    
+    setFocusProxy( d->list );
 }
 
 Sidebar::~Sidebar()

=== modified file 'ui/thumbnaillist.cpp'
--- ui/thumbnaillist.cpp	2011-12-14 13:28:07 +0000
+++ ui/thumbnaillist.cpp	2011-12-23 22:53:33 +0000
@@ -216,8 +216,8 @@
     viewport()->setPalette( viewportPal );
 
     setWidget( d );
-    // widget setup: can be focused by tab and mouse click (not wheel)
-    widget()->setFocusPolicy( Qt::StrongFocus );
+    // widget setup: can be focused by mouse click (not wheel nor tab)
+    widget()->setFocusPolicy( Qt::ClickFocus );
     widget()->show();
     QPalette widgetPal = widget()->palette();
     widgetPal.setColor( widget()->backgroundRole(), pal.color( QPalette::Base ) );

=== modified file 'ui/videowidget.cpp'
--- ui/videowidget.cpp	2011-12-14 13:28:07 +0000
+++ ui/videowidget.cpp	2011-12-23 22:53:33 +0000
@@ -219,6 +219,11 @@
     return d->geom;
 }
 
+bool VideoWidget::isPlaying() const
+{
+    return d->player->isPlaying();
+}
+
 void VideoWidget::play()
 {
     d->load();

=== modified file 'ui/videowidget.h'
--- ui/videowidget.h	2011-07-08 00:38:53 +0000
+++ ui/videowidget.h	2011-12-23 22:53:33 +0000
@@ -27,6 +27,8 @@
 
         void setNormGeometry( const Okular::NormalizedRect &rect );
         Okular::NormalizedRect normGeometry() const;
+        
+        bool isPlaying() const;
 
     public slots:
         void play();

